PAGE 1                                                                                     0100 ; INT2BITS.M65                0105 ;                 0110 ; Convert 16-bit integer into                 0115 ; string of bits.                0120 ;                 0125 ; INT2BITS USR 2 arguments:                0130 ; Value  == Integer to convert.                0135 ; StrAdr == Address of string                0140 ;           which must be able                0145 ;           to hold 16 characters                0150 ; Zero   == Character used for                0155 ;           clear bit.                0160 ; One    == Character used for                0165 ;           set bit.                0170 ;                0175 ; USR return value 0 means no                0180 ; conversion.  Non-Zero means                0185 ; STRADR contains data.                0190 ;                0195 ; Use the FR0/FR1 FP register.                0200 ; The return value for BASIC                 0205 ; goes in FR0.                0210 ; No FP is used so all of FR0                 0215 ; (and more FP registers) can                0220 ; be considered available.                0225 ;    =00D4       0230 ZRET =  $D4     ; FR0 $D4/$D5 Return value    =00D5       0235 ZARGS = $D5     ; $D6-1 for arg Pulldown loop    =00D6       0240 ZONE =  $D6     ; FR0 $D6/$D7 char for "1"    =00D8       0245 ZZERO = $D8     ; FR0 $D8/$D9 char for "0"    =00DA       0250 ZSTR =  $DA     ; FR0 $DA/$DB StrAdr    =00DC       0255 ZVAL =  $DC     ; FR0 $DC/$DD Integer value                0260 ;0000            0265     .OPT OBJ                0270 ;                0275 ; Arbitrary. This is relocatable.                0280 ;0000            0285     *=  $9300                0290 ;9300            0295 INIT9300 A900       0300     LDA #$00    ; Make sure return9302 85D4       0305     STA ZRET    ; value is cleared9304 85D5       0310     STA ZRET+1  ; by default.9306 68         0315     PLA         ; Get argument count9307 F039       0320     BEQ EXIT    ; Shortcut for no args9309 0A         0325     ASL A       ; Now number of bytes930A A8         0330     TAY 930B C908       0335     CMP #$08    ; Integer Value1, StrAdr, Zero, One930D F005       0340     BEQ PULLDOWN                0345 ;                0350 ; Bad args. Clean up for exit.                0355 ;930F            0360 DISPOSE ;       any number of args930F 68         0365     PLA 9310 88         0370     DEY 9311 D0FC       0375     BNE DISPOSE9313 60         0380     RTS         ; Abandon shipPAGE 2                                                                                     0385 ;                0390 ; This code works the same                0395 ; for 1, 4, 8 ... arguments.                0400 ;9314            0405 PULLDOWN9314 68         0410     PLA 9315 99D500     0415     STA ZARGS,Y9318 88         0420     DEY 9319 D0F9       0425     BNE PULLDOWN                0430 ;                0435 ; Arg validation.                0440 ; StrAdr may not be null.                0445 ; Zero and One may not                 0450 ; be equal.                0455 ;931B A5DA       0460     LDA ZSTR931D 05DB       0465     ORA ZSTR+1931F F021       0470     BEQ EXIT    ; zstr is null9321 A5D8       0475     LDA ZZERO9323 C5D6       0480     CMP ZONE9325 F01B       0485     BEQ EXIT    ; zero == one                 0490 ;                0495 ; Break Integer Value into                0500 ; bytes and test bits from                0505 ; high to low...                0510 ;9327 A201       0515     LDX #$01    ; X index bytes.                0520     ;           Y is already 0                0525     ;           Y index string.                0530 ;9329            0535 WALK_BITS9329 18         0540     CLC 932A 16DC       0545     ASL ZVAL,X  ; Shift out bit932C A5D8       0550     LDA ZZERO   ; Assume Zero932E 9002       0555     BCC COPY2STR ; Copy if so9330 A5D6       0560     LDA ZONE    ; Actually One 9332            0565 COPY2STR9332 91DA       0570     STA (ZSTR),Y9334 C8         0575     INY         ; Next string position9335 C008       0580     CPY #$08    ; End of high byte?9337 F004       0585     BEQ NEXT_BYTE ; Yes. Dec index.9339 C010       0590     CPY #$10    ; End of low byte?933B D0EC       0595     BNE WALK_BITS ; No, loop again.933D            0600 NEXT_BYTE933D CA         0605     DEX         ; 1, 0 will continue933E 10E9       0610     BPL WALK_BITS ; -1 ends loop9340            0615 END_LOOP                0620 ;9340 E6D4       0625     INC ZRET    ; Successful return9342            0630 EXIT9342 60         0635     RTS                 0640 ;9343            0645     .END ASSEMBLY ERRORS: 0   25329 BYTES FREEPAGE 3    SYMBOLS                                                           9332 COPY2STR         2,555    #  2,565     930F DISPOSE       #  1,360       1,375     9340 END_LOOP      #  2,615     9342 EXIT             1,320       2,470       2,485    #  2,630     9300 INIT          #  1,295     933D NEXT_BYTE        2,585    #  2,600     9314 PULLDOWN         1,340    #  2,405       2,425     9329 WALK_BITS     #  2,535       2,595       2,610    =00D5 ZARGS         #  1,235       2,415    =00D6 ZONE          #  1,240       2,480       2,560    =00D4 ZRET          #  1,230       1,305       1,310       2,625    =00DA ZSTR          #  1,250       2,460       2,465       2,570    =00DC ZVAL          #  1,255       2,545    =00D8 ZZERO         #  1,245       2,475       2,550    