PAGE 1                                                                    H1:INT2HEX.M65                0100 ; INT2HEX.M65                0105 ;                 0110 ; Convert 16-bit integer into                 0115 ; hex string.                0120 ;                 0125 ; INT2HEX USR 2 arguments:                0130 ; Value  == Integer to convert.                0135 ; StrAdr == Address of string                0140 ;           which must be able                0145 ;           to hold 4 characters                0150 ;                0155 ; USR return value 0 means no                0160 ; conversion.  Non-Zero means                0165 ; STRADR contains hex string.                0170 ;                0175 ; Use the FR0/FR1 FP register.                0180 ; The return value for BASIC                 0185 ; goes in FR0.                0190 ; No FP is used so all of FR0                 0195 ; (and more FP registers) can                0200 ; be considered available.                0205 ;    =00D4       0210 ZRET =  $D4     ; FR0 $D4/$D5 Return value    =00D5       0215 ZARGS = $D5     ; $D6-1 for arg Pulldown loop    =00D6       0220 ZSTR =  $D6     ; FR0 $D6/$D7 STRADR    =00D8       0225 ZVAL =  $D8     ; FR0 $D8/$D9 Integer value                0230 ;0000            0235     .OPT OBJ                0240 ;                0245 ; Arbitrary. This is relocatable.                0250 ;0000            0255     *=  $9400                0260 ;9400            0265 INIT9400 A900       0270     LDA #$00    ; Make sure return9402 85D4       0275     STA ZRET    ; value is cleared9404 85D5       0280     STA ZRET+1  ; by default.9406 68         0285     PLA         ; Get argument count9407 F03E       0290     BEQ EXIT    ; Shortcut for no args9409 0A         0295     ASL A       ; Now number of bytes940A A8         0300     TAY 940B C904       0305     CMP #$04    ; Integer Value1, StrAdr940D F005       0310     BEQ PULLDOWN                0315 ;                0320 ; Bad args. Clean up for exit.                0325 ;940F            0330 DISPOSE ;       any number of args940F 68         0335     PLA 9410 88         0340     DEY 9411 D0FC       0345     BNE DISPOSE9413 60         0350     RTS         ; Abandon ship                0355 ;                0360 ; This code works the same                0365 ; for 1, 4, 8 ... arguments.                0370 ;9414            0375 PULLDOWN9414 68         0380     PLA PAGE 2                                                                    H1:INT2HEX.M659415 99D500     0385     STA ZARGS,Y9418 88         0390     DEY 9419 D0F9       0395     BNE PULLDOWN                0400 ;                0405 ; Arg validation.                0410 ; StrAdr may not be null.                0415 ;                0420 ;   LDA ZSTR ; Acc holds zstr now.941B 05D7       0425     ORA ZSTR+1941D F028       0430     BEQ EXIT    ; zstr is null                0435 ;941F D8         0440     CLD                 0445 ;                0450 ; Split Integer Value into                 0455 ; nybbles and temporarily store                0460 ; in the String output...                 0465 ;9420 A201       0470     LDX #$01    ; X index bytes.                0475     ;           Y is already 0                0480     ;           Y index string.                0485 ;9422            0490 SPLIT_BYTES9422 B5D8       0495     LDA ZVAL,X  ; Byte                0500 ;                0505 ; Right shift 4 to keep                 0510 ; the high nybble.9424 4A         0515     LSR A9425 4A         0520     LSR A9426 4A         0525     LSR A9427 4A         0530     LSR A9428 91D6       0535     STA (ZSTR),Y ; Save for later                0540 ;                0545 ; Now, do the low nybble942A B5D8       0550     LDA ZVAL,X  ; Byte again942C 290F       0555     AND #$0F    ; low nybble942E C8         0560     INY         ; Next char in string942F 91D6       0565     STA (ZSTR),Y ; Save for later                0570 ;9431 C8         0575     INY         ; Next char in string9432 CA         0580     DEX         ; Next integer byte9433 10ED       0585     BPL SPLIT_BYTES                0590 ;                0595 ; Next, convert the nybbles                0600 ; saved in the string into the                0605 ; final ASCII form.                0610 ;9435 88         0615     DEY         ; Correct string index.9436            0620 BYTE2HEX9436 B1D6       0625     LDA (ZSTR),Y9438 C90A       0630     CMP #$0A    ; 10 or greater?943A 9002       0635     BCC ADD_48  ; No, 0 to 9.                0640 ;943C 6906       0645     ADC #$06    ; "A"-"0"-$0A-Carry943E            0650 ADD_48943E 6930       0655     ADC #$309440 91D6       0660     STA (ZSTR),Y9442 88         0665     DEY         ; 3, 2, 1, 0 will continue9443 10F1       0670     BPL BYTE2HEX ; -1 ends loopPAGE 3                                                                    H1:INT2HEX.M65                0675 ;9445 E6D4       0680     INC ZRET    ; Successful return9447            0685 EXIT9447 60         0690     RTS                 0695 ;9448            0700     .END ASSEMBLY ERRORS: 0   25314 BYTES FREEPAGE 4    SYMBOLS                                                         H1:INT2HEX.M65 943E ADD_48           2,635    #  2,650     9436 BYTE2HEX      #  2,620       2,670     940F DISPOSE       #  1,330       1,345     9447 EXIT             1,290       2,430    #  3,685     9400 INIT          #  1,265     9414 PULLDOWN         1,310    #  1,375       2,395     9422 SPLIT_BYTES   #  2,490       2,585    =00D5 ZARGS         #  1,215       2,385    =00D4 ZRET          #  1,210       1,275       1,280       3,680    =00D6 ZSTR          #  1,220       2,425       2,535       2,565       2,625                           2,660    =00D8 ZVAL          #  1,225       2,495       2,550    